using HermesSocketServer.Models;
using ILogger = Serilog.ILogger;

namespace HermesSocketServer.Requests
{
    public class GetTTSUsers : IRequest
    {
        public string Name => "get_tts_users";
        public string[] RequiredKeys => [];
        private ILogger _logger;

        public GetTTSUsers(ILogger logger)
        {
            _logger = logger;
        }

        public Task<RequestResult> Grant(Channel channel, IDictionary<string, object> data)
        {
            var results = channel.Chatters.Get().ToDictionary(p => p.Key, p => p.Value.VoiceId);
            _logger.Information($"Fetched all chatters' selected tts voice for channel [channel: {channel.Id}]");
            return Task.FromResult(RequestResult.Successful(results, notifyClientsOnAccount: false));
        }
    }
}