using HermesSocketLibrary.Requests.Messages;
using HermesSocketServer.Models;
using ILogger = Serilog.ILogger;

namespace HermesSocketServer.Requests
{
    public class GetTTSWordFilters : IRequest
    {
        public string Name => "get_tts_word_filters";
        public string[] RequiredKeys => [];
        private ILogger _logger;

        public GetTTSWordFilters(ILogger logger)
        {
            _logger = logger;
        }

        public Task<RequestResult> Grant(Channel channel, IDictionary<string, object> data)
        {
            IEnumerable<TTSWordFilter> filters = channel.Filters.Get().Values;

            _logger.Information($"Fetched all word filters for channel [channel: {channel.Id}]");
            return Task.FromResult(RequestResult.Successful(filters, notifyClientsOnAccount: false));
        }
    }
}