using HermesSocketServer.Store.Internal;

namespace HermesSocketServer
{
    public class ServerConfiguration
    {
        public required string Environment;
        public required WebsocketServerConfiguration WebsocketServer;
        public required DatabaseConfiguration Database;
        public required TTSConfiguration Tts;
        public string? AdminPassword;
    }

    public class WebsocketServerConfiguration
    {
        public required string Host;
        public required string Port;
    }

    public class DatabaseConfiguration
    {
        public required string ConnectionString;
        public int SaveDelayInSeconds;
        public required IDictionary<string, DatabaseTable> Tables;
    }

    public class TTSConfiguration
    {
        public long OwnerId;
        public required string DefaultTtsVoice;
    }
}